function [trainIds, classDesc]= generateTrainIds(classDesc, segs, level)

    nClasses= size(classDesc, 2);
    if nClasses == 0, classDesc= ones(3, 1) .* -1; end
    nSegs= size(segs, 2);
    trainIds= zeros(1, nSegs);
    
    for seg= 1 : nSegs
        subs= segs(level, seg).subTypes;
        if any(subs <= 0), continue; end
        ii1= subs(1) == classDesc(1, :);
        ii2= subs(2) == classDesc(2, :);
        ii3= subs(3) == classDesc(3, :);
        [value, id]= max(sum([ii1; ii2; ii3]));
        if value == 3
            trainIds(seg)= id;
        else
            nClasses= nClasses + 1;
            trainIds(seg)= nClasses;
            classDesc(:, nClasses)= [subs(1); subs(2); subs(3)];
        end
    end