function cv= compressVector(vec, nOut, normFact)

    if nargin < 3, normFact= 1; end

    nIn= length(vec);
    if nIn < nOut, error('compressVector: length(vec) is smaller than nOut!'); end
    
    cv= zeros(1, nOut);
    
    if normFact == -1
        normFact= 1;    % no normalization
    else
        normFact= normFact * nIn / nOut;    
    end
    
    inds= 0 : nIn / nOut : nIn; % borders of output segments, measured in units of input indices
    
    for p= 1 : nOut
        i1= ceil(inds(p));
        if inds(p) < i1
            cv(p)= vec(i1) * (i1 - inds(p));
        end
        i1= i1 + 1;
        i2= floor(inds(p+1));
        if i2 < inds(p+1)
            cv(p)= cv(p) + vec(i2+1) * (inds(p+1) - i2);
        end
        cv(p)= cv(p) + sum(vec(i1 : i2));
    end
    
    cv= cv ./ normFact;