function [feats, noFeats]= getFeatures(sa, level, seg, nFeatures, scaleCurveLen)

    if nargin < 5, scaleCurveLen= 0; end
    
    feats= zeros(sum(nFeatures), 1);
    noFeats= 0;
    
    if isempty(sa.segments(level, seg).start) || sa.segments(level, seg).start == 0, noFeats= 1; return; end
    
    indices(1)= sa.segments(level, seg).start;
    indices(2)= sa.segments(level, seg).end;
    
    inds= cumsum(nFeatures);
    if sa.closed == 1
        xys_= [sa.curveXY sa.curveXY];
        phis_= [sa.curvePhi sa.curvePhi];
        xys= xys_(:, indices(1) : indices(2));
        phis= phis_(indices(1) : indices(2));
    else
        xys_= sa.curveXY;
        phis_= sa.curvePhi;
        xys= xys_(:, indices(1) : indices(2));
        phis= phis_(indices(1) : indices(2));
    end
    
    if size(xys, 2) < 2 || size(phis, 2) < 2, return; end
    
    if scaleCurveLen > 0
        xys= scaleCurve(xys, scaleCurveLen);
        phis= xy2dPhidL(xys);
        phis(2, :)= [];
    end
    
    if nFeatures(1) > 0
        feats(1 : inds(1))= computeFDs(xys, nFeatures(1));
    end
    if nFeatures(2) > 0
%         feats(inds(1)+1 : inds(2))= computeMoments(xys(indices(1) : indices(2)), nFeatures(2));
        cx= dct(xys(1, :));
        cy= dct(xys(2, :));
        nFeats= floor(nFeatures(2) / 2);
        feats(inds(1)+1 : inds(2))= [cx(1 : nFeats) cy(1 : nFeats)];
    end
    if nFeatures(3) > 0
        feats(inds(2)+1 : end)= compressVector(phis, nFeatures(3), -1);
    end