function R = rotMat(alpha)

% rotMat - create a 2D rotation matrix
% 
%   R = rotMat(alpha)
%
%     returns the two-dimensional rotation matrix R
%     where alpha specifies the rotation angle degree
%     from 0 to 360.

a = alpha * pi / 180;

R(1, 1) = cos(a);    R(1, 2) = sin(a);
R(2, 1) = -sin(a);   R(2, 2) = cos(a);
